﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NGraphviz.Helpers;

namespace optimusParser
{
    /// <summary>
    /// Класс - визуализатор графа базовых блоков
    /// </summary>
    public class BBGraphVisualizator
    {
        private static Dot d = new Dot(); 
        public static void CreatePNG(BBGraph g)
        {
            string dot = "digraph G{" + "\n" + "rankdir=TB;\n" + @"node[shape=""rectangle"",font=""Courier New"", fontsize=10 ];" + "\n";
            List<BaseBlock> bl = g.ListBBlocks;
            for (int i = 0; i < bl.Count; i++)
            {
                List<Quadric> quadrics = bl[i].Quads;
                dot += bl[i].Name + @"[ shape=record ,label= ""{" + bl[i].Name + " |";
                for (int j = 0; j < quadrics.Count; j++)
                {

                    dot += quadrics[j].ToString() + @"\n";
                }
                dot += @"}""];" + "\n";
                for (int k = 0; k < g.GetParentNodes(bl[i].Name).Count; ++k)
                {
                    dot += g.GetParentNodes(bl[i].Name)[k].Name + "->" + i + @"[arrowhead=""open"",arrowtail=""none""];" + "\n";
                    //Console.WriteLine(i + " <- " + g.GetIncidentBBlocks(bl[i].Name)[k].Name);
                }
               
                //Console.WriteLine();
            }           
            dot += "}";
            d.Run(GraphvizImageType.Png, dot, "..\\..\\out.png");
        }      
    }
}
