﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace optimusParser
{
    /// <summary>
    /// Класс для оптимизаций внутри базового блока.
    /// </summary>
    class BaseBlockOptimizations
    {
        /// <summary>
        /// Оптимизация для квадрик..
        /// </summary>
        /// <param name="bbg">Граф базовых блоков.</param>
        /// <returns>Новый граф базовых блоков.</returns>
        static BaseBlockGraph Optimize(ref BaseBlockGraph bbg)
        {
            foreach (BaseBlock b in bbg.ListBBlocks)
            {
                for(int i=0;i<b.Quads.Count;i++)
                {
                    Quadric q = b.Quads[i];
                    if (q.Operation == QuadOperation.Plus && q.Var1.Equals(0) && q.Var2.Equals(0))
                    {
                        b.RemoveQuad(i);                        
                    }
                    if (q.Operation == QuadOperation.Mult && q.Var1.Equals(1) && q.Var2.Equals(1))
                    {
                        b.RemoveQuad(i);
                    }
                }
            }
            return bbg;
        }

    }
}
