﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace optimusParser
{
    public class DFA_tools
    {
        public static List<HashSet<string>> getGenD(BaseBlock b)
        {
            List<HashSet<string>> genD = new List<HashSet<string>>();
            for (int i = 0; i < b.CountQuads; ++i)
            {
                HashSet<string> hs = new HashSet<string>();
                if (b[i].Operation != QuadOperation.Goto && b[i].Operation != QuadOperation.If && b[i].Operation != QuadOperation.ToIndx)
                    hs.Add(b.Name + i.ToString());
                genD.Add(hs);
            }
            Console.WriteLine("^&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
            printListOfSet(genD);
            return genD;
        }
        public static List<HashSet<string>> getKillD(BaseBlock b, BBGraph g)
        {
            List<HashSet<string>> killD = new List<HashSet<string>>();
            for (int i = 0; i < b.CountQuads; ++i)
            {
                HashSet<string> hs = new HashSet<string>();
                if (b[i].Operation != QuadOperation.Goto && b[i].Operation != QuadOperation.If && b[i].Operation != QuadOperation.ToIndx)
                {
                    string d = b[i].Result.ToString();
                    string label1 = b.Name + i.ToString();
                    List<BaseBlock> bbg = g.ListBBlocks;

                    for (int j = 0; j < bbg.Count; ++j)
                    {
                        BaseBlock bb = bbg[j];
                        for (int k = 0; k < bb.CountQuads; ++k)
                        {
                            string label2 = bb.Name + k.ToString();
                            if (label1 != label2 && d == bb[k].Result.ToString())
                                hs.Add(label2);
                        }
                    }
                }
                killD.Add(hs);
            }
            //Console.WriteLine("^&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
            //printListOfSet(killD);
            return killD;
            
        }

        public static void printListOfSet(List<HashSet<string>> lhs)
        {
            for (int i = 0; i < lhs.Count; ++i)
            {
                Console.Write(i.ToString() + ": ");
                DFA_tools.printSet(lhs[i]);
            }
        }

        public static HashSet<string> getKillB(List<HashSet<string>> killDs)
        {
            // находим  множество killB для базового блока на основании killd для каждого оператора блока
            HashSet<string> res = new HashSet<string>();
            foreach (HashSet<string> killd in killDs)
            {
                // берем объединение всех множеств
                res.UnionWith(killd);
            }
            //printSet(res);
            return res;            
        }

        public static HashSet<string> getGenB(List<HashSet<string>> genDs, List<HashSet<string>> killDs)
        {
            HashSet<string> res = new HashSet<string>();
            int k = 0;
            for (int i = genDs.Count - 1; i >= 0; i--)
            {
                HashSet<string> set = new HashSet<string>();
                set.UnionWith(genDs[i]);
                for (int j = 0; j < k; j++)
                    set.ExceptWith(killDs[killDs.Count - 1 - j]);
                res.UnionWith(set);
                k++;
            }
            printSet(res);
            return res;
        }
        public static HashSet<string> transferFuncB(HashSet<string> x, HashSet<string> genB, HashSet<string> killB)
        {
            HashSet<string> res = new HashSet<string>();
            res.UnionWith(x);
            res.ExceptWith(killB);
            res.UnionWith(genB);
            return res;
        }
        public static void printSet(HashSet<string> set)
        {
            foreach (string s in set)
                Console.Write(s + " ");
            Console.WriteLine();
        }
    }
}
